declare -Ag appRollCall # Associative array for storing app status
declare -Ag fileRollCall # Associative array for storing file status
declare -Ag dirRollCall # Associative array for storing dir status
+declare -a recPubKeys # for processArguments function
+declare recipients # for main function
#===BEGIN Declare local script functions===
checkapp() {
} # Define stderr message function.
showUsage() {
echoerr "USAGE:"
- echoerr " bkgpslog.sh [ options ]"
+ echoerr " bkgpslog [ options ]"
echoerr
echoerr "OPTIONS:"
echoerr " -h, --help"
echoerr " -v, --verbose"
echoerr " Display debugging info."
echoerr
+ echoerr " -e, --encrypt"
+ echoerr " Encrypt output."
+ echoerr
+ echoerr " -r, --recipient [ pubkey string ]"
+ echoerr " Specify recipient."
+ echoerr
echoerr " -o, --output [ directory ]"
echoerr " Specify output directory to save logs."
+ echoerr
+ echoerr " -c, --compress"
+ echoerr " Compress output with gzip (before encryption if enabled)."
+ echoerr
+ echoerr "EXAMPLE: (bash script lines)"
+ echoerr "/bin/bash bkgpslog -e -c \\"
+ echoerr "-r age1mrmfnwhtlprn4jquex0ukmwcm7y2nxlphuzgsgv8ew2k9mewy3rs8u7su5 \\"
+ echoerr "-r age1ala848kqrvxc88rzaauc6vc5v0fqrvef9dxyk79m0vjea3hagclswu0lgq \\"
+ echoerr "-o ~/Sync/Location"
} # Display information on how to use this script.
showVersion() {
echoerr "$SCRIPT_VERSION"
} # Verbose message display function.
processArguments() {
while [ ! $# -eq 0 ]; do # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
- echoerr "DEBUG:Starting processArguments while loop."
- echoerr "DEBUG:Provided arguments are:""$*"
+ #echoerr "DEBUG:Starting processArguments while loop."
+ #echoerr "DEBUG:Provided arguments are:""$*"
case "$1" in
- --h | --help) showUsage; exit 1;; # Display usage.
+ -h | --help) showUsage; exit 1;; # Display usage.
--version) showVersion; exit 1;; # Show version
- --v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
- --o | --output) if [ -d "$2" ]; then DIROUT="$2"; vbm "DEBUG:DIROUT:$DIROUT"; shift; fi ;; # Define output directory.
+ -v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
+ -o | --output) if [ -d "$2" ]; then DIROUT="$2"; vbm "DEBUG:DIROUT:$DIROUT"; shift; fi ;; # Define output directory.
+ -e | --encrypt) OPTION_ENCRYPT="true"; vbm "DEBUG:Encrypted output mode enabled.";;
+ -r | --recipient) # Add 'age' recipient via public key string
+ recPubKeys+=("$2"); vbm "pubkey added:""$2"; shift;;
+ -c | --compress) OPTION_COMPRESS="true"; vbm "DEBUG:Compressed output mode enabled.";;
*) echoerr "ERROR: Unrecognized argument."; exit 1;; # Handle unrecognized options.
esac
shift
done
} # Argument Processing
-timeUntilMidnight(){
- # Desc: Report seconds until midnight
- # Output: stdout: integer seconds until midnight
+timeUntilNextDay(){
+ # Desc: Report seconds until next day.
+ # Output: stdout: integer seconds until next day
# Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
- # Usage: timeUntilMidnight
- # Usage: if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement"; exit 1; fi
- local returnState
+ # Usage: timeUntilNextDay
+ # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
+ local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
- TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)" # Produce separator-less current timestamp with resolution 1 second.
- DATE_CURRENT="$(date -d "$TIME_CURRENT" --iso-8601=date)" ; # Produce `date`-parsable current timestamp with resolution of 1 day.
- DATE_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%d)" ; # Produce separator-less current timestamp with resolution 1 day.
- DATE_TOMORROW="$(date -d "$TIME_CURRENT next day" --iso-8601=date)" ; # Produce timestamp of tomorrow's date (res. 1 day).
- TIME_NEXT_MIDNIGHT="$(date -d "$DATE_TOMORROW" --iso-8601=seconds)" ; # Produce `date`-parsable timestamp of closest future midnight (res. 1 second).
- SECONDS_UNTIL_NEXT_MIDNIGHT="$(( $(date +%s -d "$TIME_NEXT_MIDNIGHT") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
- if [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -gt 0 ]]; then
+ TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
+ SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
+ if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
+ returnState="true";
+ elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
+ returnState="WARNING_ZERO";
+ yell "WARNING:Reported time until next day exactly zero.";
+ elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
+ returnState="WARNING_NEGATIVE";
+ yell "WARNING:Reported time until next day is negative.";
+ fi
+
+ try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
+
+ #===Determine function return code===
+ if [[ "$returnState" = "true" ]]; then
+ return 0;
+ elif [[ "$returnState" = "WARNING_ZERO" ]]; then
+ return 1;
+ elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
+ return 2;
+ fi
+} # Report seconds until next day
+timeUntilNextHour(){
+ # Desc: Report seconds until next hour
+ # Output: stdout: integer seconds until next hour
+ # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
+ # Usage: timeUntilNextHour
+ # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
+ local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
+ TIME_CURRENT="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
+ TIME_NEXT_HOUR="$(date -d "$TIME_CURRENT next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
+ SECONDS_UNTIL_NEXT_HOUR="$(( $(date +%s -d "$TIME_NEXT_HOUR") - $(date +%s -d "$TIME_CURRENT") ))"; # Calculate seconds until next hour (res. 1 second).
+ if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
returnState="true";
- elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -eq 0 ]]; then
+ elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
returnState="WARNING_ZERO";
- yell "WARNING:Reported time until midnight exactly zero.";
- elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -lt 0 ]]; then
+ yell "WARNING:Reported time until next hour exactly zero.";
+ elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
returnState="WARNING_NEGATIVE";
- yell "WARNING:Reported time until midnight is negative.";
+ yell "WARNING:Reported time until next hour is negative.";
fi
- try echo "$SECONDS_UNTIL_NEXT_MIDNIGHT"; # Report
+ try echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
#===Determine function return code===
if [[ "$returnState" = "true" ]]; then
elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
return 2;
fi
-} # Report seconds until next midnight
+} # Report seconds until next hour
dateTimeShort(){
# Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
# Usage: dateTimeShort
# Output: stdout: timestamp (ISO-8601, no separators)
+ local TIME_CURRENT TIME_CURRENT_SHORT
TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)"; # Produce separator-less current timestamp with resolution 1 second.
echo "$TIME_CURRENT_SHORT";
} # Get date&time without separators
main() {
processArguments "$@" # Process arguments.
+ if [[ "$OPTION_ENCRYPT" = "true" ]]; then # Check if encryption option active.
+ if checkapp age; then # Check that age is available.
+ for pubkey in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
+ vbm "DEBUG:Testing pubkey string:$pubkey"
+ if echo "butts" | age -a -r "$pubkey" 1>/dev/null; then
+ # Form age recipient string
+ recipients="$recipients""-r $pubkey ";
+ vbm "Added pubkey for forming age recipient string:""$pubkey";
+ vbm "DEBUG:recipients:""$recipients";
+ else
+ yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
+ fi
+ done
+ vbm "DEBUG:Finished processing recPubKeys array";
+ # Form age command string
+ CMD_ENCRYPT=" | age ""$recipients ";
+ CMD_ENCRYPT_SUFFIX=".age";
+ else
+ yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
+ fi
+ else
+ CMD_ENCRYPT="";
+ CMD_ENCRYPT_SUFFIX="";
+ vbm "DEBUG:Encryption not enabled."
+ fi
+
+ if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
+ if checkapp gzip; then # Check if gzip available
+ CMD_COMPRESS=" | gzip ";
+ CMD_COMPRESS_SUFFIX=".gz";
+ else
+ yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
+ else
+ CMD_COMPRESS="";
+ CMD_COMPRESS_SUFFIX="";
+ vbm "DEBUG:Compression not enabled."
+ fi
+
+
if checkapp gpspipe && checkdir "$DIROUT"; then
- # Determine output file paths
- FILEOUT_NMEA="$(dateTimeShort)".."$SCRIPT_HOSTNAME"_location.nmea ;
- #FILEOUT_GPX="" ;
- #FILEOUT_KML="" ;
+
+ # # Set script lifespan to end at start of next day
+ # if ! scriptTTL="$(timeUntilNextDay)"; then
+ # if [[ "$scriptTTL" -eq 0 ]]; then
+ # ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+ # else
+ # yell "ERROR: timeUntilNextDay exit code $?"; exit 1;
+ # fi;
+ # fi;
- # Determine script lifespan (note: exit if <= 0 since 'timeout' runs forever if provided "0s".
- #if ! scriptTTL="$(timeUntilMidnight)"; then yell "ERROR: timeUntilMidnight exit code $?"; exit 1; fi
- scriptTTL="60"; #DEBUG DEBUG DEBUG DEBUG
+ # Set script lifespan to end at start of next hour
+ if ! scriptTTL="$(timeUntilNextHour)"; then
+ if [[ "$scriptTTL" -eq 0 ]]; then
+ ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+ else
+ yell "ERROR: timeUntilNextHour exit code $?"; exit 1;
+ fi;
+ fi;
# Determine buffer lifespan
- bufferTTL="15";
+ bufferTTL="60";
- # Record gps data until life ends
+ # Record gps data until script lifespan ends
declare debugCounter; debugCounter="0"
while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
((debugCounter++))
- timeout "$bufferTTL""s" gpspipe -r 1>> "$DIROUT"/"$FILEOUT_NMEA""$debugCounter"
- vbm "DEBUG:Completed buffer session." 1>&2;
+ # Determine output file paths (time is start of buffer period)
+ FILEOUT_BASENAME="$(dateTimeShort)""--P""$bufferTTL""S..""$SCRIPT_HOSTNAME""_location" ; # ISO-8601 YYYYmmddTHHMMSS+zzP[$bufferTTL]S
+ FILEOUT_NMEA="$FILEOUT_BASENAME".nmea"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
+ FILEOUT_GPX="$FILEOUT_BASENAME".gpx"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
+ FILEOUT_KML="$FILEOUT_BASENAME".kml"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
+ # Fill buffer
+ buffer="$(timeout "$bufferTTL""s" gpspipe -r)"; # Record gpspipe nmea data to buffer for bufferTTL seconds
+ # Process and save buffers
+ echo "$buffer" "$CMD_COMPRESS" "$CMD_ENCRYPT" > "$DIROUT"/"$FILEOUT_NMEA" & # Save NMEA format
+ echo "$buffer" | gpsbabel -i nmea -f - -o gpx -F - "$CMD_COMPRESS" "$CMD_ENCRYPT" > "$DIROUT"/"$FILEOUT_GPX" & # Save GPX format
+ echo "$buffer" | gpsbabel -i nmea -f - -o kml -F - "$CMD_COMPRESS" "$CMD_ENCRYPT" > "$DIROUT"/"$FILEOUT_KML" & # Save KML format
+ vbm "DEBUG:Completed buffer session $debugCounter ." 1>&2;
+ # Reset buffer and filenames
+ unset buffer FILEOUT_BASENAME FILEOUT_NMEA FILEOUT_GPX FILEOUT_KML;
done
fi
} # Main function.